//=============================================================================
// Change_Tough_MZ.js
//   Last update: 2024/09/22
//=============================================================================
// 更新っぽいもの
// 
// 2024/09/22 [v0.1.0]
// 初版

/*:
 * @target MZ
 * 
 * @plugindesc
 * [v0.1.0] Change!! Tough MZ.
 * 
 * @author Diamond
 *
 * @param Tough Skill ID
 * @text ????
 * @default 167
 * @type skill
 * @desc
 * English is not supported.
 * Please Use Japanese!!
 * 
 * @help
 * Diamond use ruby, not use Java Script!!
 * Please use Ruby!! and RPG Tkool XP/VX/VX Ace.
 * 
 * @url https://diamond.iza-yoi.net/
 */

/*:ja
 * @target MZ
 * 
 * @plugindesc
 * [v0.1.0] 真（チェンジ！！）頑丈 MZ
 * 
 * @author 貪藻矢射妥←
 *
 * @param Tough Skill ID
 * @text 「頑丈」のスキルID
 * @default 167
 * @type skill
 * @desc 「頑丈」のスキルIDを設定
 *
 * @help
 * ポケ○ンの特性にある致死ダメージを受けてもHP 1で持ちこたえるってアレ。
 * 寧ろ特性じゃなく道具の「気合のタスキ」とか「気合のハチマキ」みたいな感じ。
 * 
 * なお、HPが最大の時に限るみたいな考慮は面倒なので「気合のハチマキ」っぽい
 * 感じで実装します。
 * また、ポ○モンだと「気合のハチマキ」の効果は確率で戦闘中1回だけですけど、
 * そんな考慮も面倒なのでHPが1より大きければ何度でも発生する仕様となります。
 * また、発動すると大量ダメージ食らうけどなんとか持ちこたえるって感じではなく
 * 現存HP - 1 のダメージを食らうって感じになりますが、それも仕様です。
 * （そこまで考慮するのが面倒なので、貪藻矢射妥←は考えるのをやめた）
 *
 * Java ScriptよりもRubyを使いたい！ by 貪藻矢射妥←
 * 
 * @url https://diamond.iza-yoi.net/
 */


var OuterFlg = OuterFlg || {};

(() => {

'use strict';

OuterFlg.imported = OuterFlg.imported || {};
OuterFlg.imported['Tough'] = true;

var pluginParams       = PluginManager.parameters('Change_Tough_MZ');
var changeToughSkillId = Number(pluginParams['Tough Skill ID'] || 167);

//var ParamsEx          = PluginManagerEx.createParameter(document.currentScript);
//var ParamsEx_hogehoge = ParamsEx['hogehogeStruct'];


//-----------------------------------------------------------------------------
// Game_Action

Game_Action.prototype.executeHpDamage = function(target, value) {
    var changeDamage = value;
    if ( target.isActor() && target.skills().includes($dataSkills[changeToughSkillId]) && 
         target._hp > 1 && value > 0 ) {
        // 「頑丈」のステートにかかっている場合、かつ現在HPが1より大きい場合、
        // ダメージを現在HP - 1 に設定する
        changeDamage = target._hp - 1;
    }
    
    if (this.isDrain()) {
        changeDamage = Math.min(target.hp, value);
    }
    this.makeSuccess(target);
    target.gainHp(-changeDamage);
    if (value > 0) {
        target.onDamage(value);
    }
    this.gainDrainedHp(changeDamage);
};


})();
